<template>
  <column>
    <row v-for="(layer, index) in internal" :key="layer.url">
      <button :disabled="index == 0" @click="pushUp(index)">&#x25B2;</button>
      <button :disabled="index == internal.length - 1" @click="pushDown(index)">
        &#x25BC;
      </button>
      <input v-model="layer.enabled" type="checkbox" />
      <span class="name">
        {{ layer.name }}
      </span>
      <input
        :disabled="!layer.enabled"
        v-model="layer.opacity"
        type="range"
        min="0"
        max="1"
        step="0.05"
      />
    </row>
  </column>
</template>
<style lang="scss" scoped>
@import "~assets/mixins.scss";

.name {
  flex-grow: 1;
}

input[type="range"] {
  width: $grid * 2;
}
</style>
<script>
import TileProviders from "~/lib/tile_providers";

export default {
  props: ["value"],
  data() {
    return {
      internal: TileProviders.map((p, i) => ({
        ...p,
        enabled: i == 0,
        opacity: 1,
      })),
    };
  },
  mounted() {
    this.emit();
  },
  watch: {
    internal: {
      deep: true,
      handler() {
        this.emit();
      },
    },
  },

  methods: {
    pushDown(index) {
      var r = this.internal.splice(index, 1)[0];
      this.internal.splice(index + 1, 0, r);
      this.emit();
    },
    pushUp(index) {
      var r = this.internal.splice(index, 1)[0];
      this.internal.splice(index - 1, 0, r);
      this.emit();
    },
    emit: function () {
      let out = this.internal.filter((a) => a.enabled);
      console.log("Emitting", out);

      this.$emit("input", out);
    },
  },
};
</script>
